// ClockDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "RemoteTest.h"
#include "ClockDlg.h"
#include "RemoteTestDlg.h"


#define SAFE_DELETE( p )  { if ( p ) { delete ( p );     ( p ) = NULL; } }
#define SAFE_RELEASE( p ) { if ( p ) { ( p )->Release(); ( p ) = NULL; } }


CClockDlg::CClockDlg( CVAIBO *vaibo, CWnd* pParent/*=NULL*/ )
    : CDialog( CClockDlg::IDD, pParent )
{
    //{{AFX_DATA_INIT(CClockDlg)
    //}}AFX_DATA_INIT

    // Virtual AIBO
    m_vaibo = vaibo;
}


void CClockDlg::DoDataExchange( CDataExchange* pDX )
{
    CDialog::DoDataExchange( pDX );
    //{{AFX_DATA_MAP(CClockDlg)
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP( CClockDlg, CDialog )
    //{{AFX_MSG_MAP(CClockDlg)
    ON_BN_CLICKED( IDC_BTN_SET_CLOCK, OnSetClock )
    ON_WM_DESTROY()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL    CClockDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CTime   time = CTime::GetCurrentTime();

    CString     str;
    str.Format( "2004");
    editYear().SetWindowText( ( LPCTSTR )str );
    str.Format( "" );
    editMonth().SetWindowText( ( LPCTSTR )str );
    editDay().SetWindowText( ( LPCTSTR )str );
    editHour().SetWindowText( ( LPCTSTR )str );
    editMinute().SetWindowText( ( LPCTSTR )str );
    editSecond().SetWindowText( ( LPCTSTR )str );


    return TRUE;
}

void CClockDlg::OnDestroy()
{
    CDialog::OnDestroy();
}

void CClockDlg::OnSetClock()
{

    CString     str;
    int     nYear, nMonth, nDay, nHour, nMinute, nSecond;

    editYear().GetWindowText( str );
    nYear = atoi( str );
    if ( ( nYear < 0 ) || ( nYear > 9999 ) ) {
        AfxMessageBox( "Year value is invalid\n" );
        return;
    }
    editMonth().GetWindowText( str );
    nMonth = atoi( str );
    if ( ( nMonth < 1 ) || ( nMonth > 12 ) ) {
        AfxMessageBox( "Month value is invalid\n" );
        return;
    }
    editDay().GetWindowText( str );
    nDay = atoi( str );
    if ( ( nDay < 1 ) || ( nDay > 31 ) ) {
        AfxMessageBox( "Day value is invalid\n" );
        return;
    }
    editHour().GetWindowText( str );
    nHour = atoi( str );
    if ( ( nHour < 0 ) || ( nHour > 23 ) ) {
        AfxMessageBox( "Hour value is invalid\n" );
        return;
    }
    editMinute().GetWindowText( str );
    nMinute = atoi( str );
    if ( ( nMinute < 0 ) || ( nMinute > 59 ) ) {
        AfxMessageBox( "Minute value is invalid\n" );
        return;
    }
    editSecond().GetWindowText( str );
    nSecond = atoi( str );
    if ( ( nSecond < 0 ) || ( nSecond > 59 ) ) {
        AfxMessageBox( "Second value is invalid\n" );
        return;
    }

    int Err = m_vaibo->SetClock(
                    ( nYear << 16 ) | ( nMonth << 8 ) | nDay,       // 0xYYYYMMDD
                    ( nHour << 16 ) | ( nMinute << 8 ) | nSecond,   // 0x00HHMMSS
                     true                                           // Wait for command completion
    );

    if (Err < 0) 
        AfxMessageBox( "CVAIBO::SetClock is not implemented yet\n" );
    
}
